# Ionix Identify TCL #
# 
# Usable on:
# DALnet, Ionix and OpenProjects.
# 
# Additionally you can use it on all Networks, which uses
# similar nickserv/chanserv identification.
# Means, using:
# /nickserv identify <password>
#
# /msg nickserv identify is NOT supported, but, it can be added easily.
#
#
# This Script is developed by: 
# Alpha-]x[ (chris@ionical.idlegames.com)
# Ionix Scripter/Coder Comunity 1st Admin
# irc.Ionical.IdleGames.com:6667 #ionix
#
# If you have any questions, e-mail me, or visit me on IRC.
#
# ADVERTISEMENT:
# Ionix is a Scripter/Coder Comunity.
# We are always searching new Members.
# You're always welcome on our IRC to see
# what we are, and if you could be interested in
# joining us.
#
# Additionally we have relay channels you can visit aswell:
# DALnet: #ionix
# OpenProjects: #ionix
#
# If noone is in the channel you joined, just say anything.
# Anyone else on the other Networks, which are relayed, can see
# what you're typing.

# FLAGS Used:
#
# *|+n - All Commands. 
# We on Ionix don't need it another way.
# If YOU need it another way, like a identify system for
# allowing normal channel ops (*|o) to use .id op chan,
# contact me. If I get enough requests I WILL add this feature.
#
# If I get enough requests for something different, I WILL add it aswell.

# If you need a TCL which can do something special, visit us on our IRC, or
# any relay channel, and tell us about that. If any scripter is interested in
# scripting it, he will tell you. We have request-anouncements for Scripters/Coders
# if anyone, in our Comunity or outside, needs something.
# 
# Now, go, configure and have fun :o).

## CONFIG SECTION ##

# Identify TCL Trigger (Default = ".")
set id(trigger) "."

# Auth Type:
# 1 = Nickserv/Chanserv identify.
# 2 = Nickserv/Chanserv identify + /oper.
# On connect, the bot ALWAYS identifys to nickserv and maybe /opers up depending
# on this config. If you don't want the bot to automatically get op, don't
# have the bot at AutoOp access on the channels.
# If you set this to 2, you have to know, that mode-changes only work with PTlink ircD
# or any other ircD which supports mode-hacking with: /samode <chan> <+/-mode> (nick)
set id(autht) "2"

# Nickserv name (Case-Sensitive)
set id(nsname) "NickServ"

# Chanserv name (Case-Sensitive)
set id(csname) "ChanServ"

# Nickserv Pass:
set id(nspass) "nspass"

# Oper IDNick (only used by $id(autht) 2:
set id(oidnick) "oidnick"

# Oper Password (only used by $id(autht) 2:
set id(opass) "opass"

# The string, which nickserv sends, when it thinks that the nick the bot is using is owned by
# someone else. This is used for detecting Services-Rejoins (to the network). The bot will
# identify itself then. Mostly Nickserv sends more then one notice. The notice is split in
# several lines. Please set only ONE COMPLETE line, nickserv sends here
set id(nsmsg) "please choose a different nick."

## END CONFIG SECTION, DONT EDIT BELOW IF YOU DON'T KNOW WHAT YOU'RE DOING ##

set id(ver) "identify.tcl v0.2 by Alpha-\]x\["
set id(con) "0"

bind evnt - init-server id:connect
bind evnt - disconnect-server id:disconnect
bind pub n $id(trigger)id id:id
bind pub n $id(trigger)idhelp id:idhelp
bind notc - $id(nsmsg) id:aid

proc id:disconnect {type args} {
	global id

	set id(con) "0"

	return 0
}

proc id:connect {type args} {
	global id
	
	if {$id(autht) == "1"} {
		putquick "$id(nsname) identify $id(nspass)"
		putlog "*** identify.tcl - Identified. (AuthType 1)"
	} elseif {$id(autht) == "2"} {
		putquick "$id(nsname) identify $id(nspass)"
		puthelp "OPER $id(oidnick) $id(opass)"
		putlog "*** identify.tcl - Identified. (AuthType 2)"
	} else {
		putlog "ERROR: identify.tcl - Please check your configuration!"
	}
	
	set id(con) "1"
	
return 0
}

proc id:id {n uh h c text} {
	global id botnick

	if {[llength $text] == 0} {
		puthelp "NOTICE $n :Wrong usage. Use:"
		puthelp "NOTICE $n :$id(trigger)id (what) (where)"
		puthelp "NOTICE $n :-"
		puthelp "NOTICE $n :If you need additional help, do:"
		puthelp "NOTICE $n :$id(trigger)idhelp"
		return 0
	}
	
	set what [lindex $text 0]
	set where [lindex $text 1]
	
	if {$what != "op" && $what != "auth"} {
		puthelp "NOTICE $n :Wrong usage. Type: $id(trigger)idhelp"
		return 0
	}
	if {$what == "op"} {
		if {$where == ""} {
			puthelp "NOTICE $n :Wrong usage. Type: $id(trigger)idhelp"
			return 0
		}
	} elseif {$what == "auth"} {
		if {$where != ""} {
			puthelp "NOTICE $n :Please use \002auth\002 without any additional arguments"
			return 0
		}
	}
	
	if {$id(autht) == "1"} {
		if {$what == "auth"} {
			putserv "$id(nsname) identify $id(nspass)"
			puthelp "NOTICE $n :Identified to: $id(nsname)"
		} elseif {$what == "op"} {
			if {$where == "chan"} {
				putserv "$id(csname) op $c $botnick"
				puthelp "NOTICE $n :Requested ops in $c"
			} elseif {$where == "global"} {
				id:checkop
				}			
		} else {
			puthelp "NOTICE $n :Wrong usage. Use:"
			puthelp "NOTICE $n :$id(trigger)id auth $where or"
			puthelp "NOTICE $n :$id(trigger)id op $where"
			puthelp "NOTICE $n :-"
			puthelp "NOTICE $n :If you need additional help, do:"
			puthelp "NOTICE $n :$id(trigger)idhelp"
		}
	} elseif {$id(autht) == "2"} {
		if {$what == "auth"} {
			putserv "$id(nsname) identify $id(nspass)"
			puthelp "NOTICE $n :Identified to $id(nsname)."
			putserv "OPER $id(oidnick) $id(opass)"
			puthelp "NOTICE $n :Opered up. Identification complete."
		} elseif {$what == "op"} {
			if {$where == "chan"} {
				putserv "SAMODE $c +o $botnick"
				puthelp "NOTICE $n :Requested ops in $c"
			} elseif {$where == "global"} {
				id:checkop
			}
				}
			}
	return 0
}

proc id:idhelp {n uh h c text} {
	global id
	
		puthelp "PRIVMSG $n :$id(ver) Help"
		puthelp "PRIVMSG $n :\037Usage\037:"
		puthelp "PRIVMSG $n :$id(trigger)id (what) (where)"
		puthelp "PRIVMSG $n :\037Description\037:"
		puthelp "PRIVMSG $n :(what) - One of: op or auth"
		puthelp "PRIVMSG $n :\002op\002 - Get OP"
		if {$id(autht) == "1"} {
			puthelp "PRIVMSG $n :\002auth\002 - Identify to Nickserv"
		} elseif {$id(autht) == "2"} {
		puthelp "PRIVMSG $n :\002auth\002 - Identify to Nickserv and /oper up"
		} else {
			puthelp "PRIVMSG $n :\037\002WARNING\037\002: Something is wrong with the config!"
		}
		puthelp "PRIVMSG $n :-"
		puthelp "PRIVMSG $n :(where) - One of: chan or global"
		puthelp "PRIVMSG $n :\002chan\002 - Only get op in the channel the command is used"
		puthelp "PRIVMSG $n :\002global\002 - Try getting op in ALL channels the bot is in"
		puthelp "PRIVMSG $n :-:"
		puthelp "PRIVMSG $n :\037NOTE\037: (where) is only used with the 'op' argument."

		return 0
	}


proc id:aid {n uh h args {dest ""}} {
	global id botnick

	if {$dest == ""} { set dest $botnick }

	if {$id(con) == "1"} { return 0 }
	
	if {$n == $id(nsname)} {
		id:auth
		id:checkop
		putlog "*** identify.tcl: $id(nsname) Netrejoin. Identified and checked ops."
	} else { putlog "*** identify.tcl: Someone triggered $id(nsname) Netrejoin AutoDetection." }

	return 0
}

proc id:auth {args} {
	global id
	
	if {$id(autht) == "1"} {
		putserv "$id(nsname) identify $id(nspass)"
		putlog "*** identify.tcl: Identified to $id(nsname)"
	} elseif {$id(autht) == "2"} {
		putserv "$id(nsname) identify $id(nspass)"
		putserv "OPER $id(oidnick) $id(opass)"
		putlog "*** identify.tcl: Identified to $id(nsname) and /opered up."
	} else { putlog "*** identify.tcl: ERROR - Configuration Error. Can't identify." }

	return 0
}

proc id:checkop {args} {
	global id botnick

	foreach chan [channels] {
		if {$id(autht) == "1"} {
			if{![botisop $chan]} {
			putserv "$id(csname) op $chan $botnick"
		}
		} elseif {$id(autht) == "2"} {
			if {![botisop $chan]} {
				putserv "SAMODE $chan +o $botnick"
			}
		} else {
			putlog "*** identify.tcl: ERROR - Configuration Error. Can't check for ops."
		}
	}

		return 0
	}

	
putlog "*** $id(ver) loaded."
